Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/wet_dry.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/wet_dry.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/DYN/wet_dry.F90	(revision 10986)
@@ -104,7 +104,11 @@
          WRITE(numout,*) '      cut off depth sbc for wd   rn_wd_sbcdep       = ', rn_wd_sbcdep
          WRITE(numout,*) '      fraction to start sbc wgt rn_wd_sbcfra        = ', rn_wd_sbcfra
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       IF( .NOT. ln_read_cfg ) THEN
-         IF(lwp) WRITE(numout,*) '      No configuration file so seting ssh_ref to zero  '
+         IF(lwp) THEN
+            WRITE(numout,*) '      No configuration file so seting ssh_ref to zero  '
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          ssh_ref=0._wp
       ENDIF
@@ -266,5 +270,8 @@
 !!gm
       !
-      IF(jflag == 1 .AND. lwp)   WRITE(numout,*) 'Need more iterations in wad_lmt!!!'
+      IF(jflag == 1 .AND. lwp)   THEN
+         WRITE(numout,*) 'Need more iterations in wad_lmt!!!'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       !IF( ln_rnf      )   CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
@@ -390,5 +397,8 @@
 !!gm end
       !
-      IF( jflag == 1 .AND. lwp )   WRITE(numout,*) 'Need more iterations in wad_lmt_bt!!!'
+      IF( jflag == 1 .AND. lwp )   THEN
+         WRITE(numout,*) 'Need more iterations in wad_lmt_bt!!!'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
       !IF( ln_rnf      )   CALL sbc_rnf_div( hdivn )          ! runoffs (update hdivn field)
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/flo4rk.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/flo4rk.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/flo4rk.F90	(revision 10986)
@@ -58,12 +58,16 @@
       !
       IF( ierror /= 0 ) THEN
-         WRITE(numout,*) 'flo_4rk: allocation of workspace arrays failed'
+         IF(lwp) THEN
+            WRITE(numout,*) 'flo_4rk: allocation of workspace arrays failed'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       ENDIF
 
     
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'flo_4rk : compute Runge Kutta trajectories for floats '
-         IF(lwp) WRITE(numout,*) '~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'flo_4rk : compute Runge Kutta trajectories for floats '
+         WRITE(numout,*) '~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -114,4 +118,6 @@
          ENDIF
       END DO
+     
+      IF(lflush .AND. lwp) CALL FLUSH(numout)
       
       ! 4 steps of Runge-Kutta algorithme
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/floats.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/floats.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/floats.F90	(revision 10986)
@@ -84,7 +84,10 @@
       !!---------------------------------------------------------------------
       !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'flo_stp : call floats routine '
-      IF(lwp) WRITE(numout,*) '~~~~~~~'
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'flo_stp : call floats routine '
+         WRITE(numout,*) '~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
 
       REWIND( numnam_ref )              ! Namelist namflo in reference namelist : Floats
@@ -109,5 +112,5 @@
          WRITE(numout,*) '            Use of ariane convention              ln_ariane    = ', ln_ariane
          WRITE(numout,*) '            ascii output (T) or netcdf output (F) ln_flo_ascii = ', ln_flo_ascii
-
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/floblk.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/floblk.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/floblk.F90	(revision 10986)
@@ -71,8 +71,9 @@
       !!---------------------------------------------------------------------
 
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'flo_blk : compute Blanke trajectories for floats '
-         IF(lwp) WRITE(numout,*) '~~~~~~~ '
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'flo_blk : compute Blanke trajectories for floats '
+         WRITE(numout,*) '~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/flodom.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/flodom.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/flodom.F90	(revision 10986)
@@ -59,7 +59,10 @@
       ! Initialisation with the geographical position or restart
       
-      IF(lwp) WRITE(numout,*) 'flo_dom : compute initial position of floats'
-      IF(lwp) WRITE(numout,*) '~~~~~~~~'
-      IF(lwp) WRITE(numout,*) '           jpnfl = ',jpnfl
+      IF(lwp) THEN
+         WRITE(numout,*) 'flo_dom : compute initial position of floats'
+         WRITE(numout,*) '~~~~~~~~'
+         WRITE(numout,*) '           jpnfl = ',jpnfl
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       
       !-------------------------!
@@ -89,5 +92,8 @@
          IF( jpnfl > jpnrstflo )THEN
 
-            IF(lwp) WRITE(numout,*) '        add new floats'
+            IF(lwp) THEN
+               WRITE(numout,*) '        add new floats'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
 
             IF( ln_ariane )THEN  !Add new floats with ariane convention
@@ -145,5 +151,8 @@
       DO jfl = kfl_start,kfl_end
          READ(inum,*) flxx(jfl),flyy(jfl),flzz(jfl), nisobfl(jfl),ngrpfl(jfl),itrash
-         if(lwp)write(numout,*)'read:',jfl,flxx(jfl),flyy(jfl),flzz(jfl), nisobfl(jfl),ngrpfl(jfl),itrash ; call flush(numout)
+         IF(lwp) THEN
+            write(numout,*)'read:',jfl,flxx(jfl),flyy(jfl),flzz(jfl), nisobfl(jfl),ngrpfl(jfl),itrash
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       END DO
       CLOSE(inum)
@@ -266,10 +275,13 @@
          DO jfl =  kfl_start,kfl_end
             IF( idomfl(jfl) == 1 ) THEN
-               IF(lwp) WRITE(numout,*)'*****************************'
-               IF(lwp) WRITE(numout,*)'!!!!!!!  WARNING   !!!!!!!!!!'
-               IF(lwp) WRITE(numout,*)'*****************************'
-               IF(lwp) WRITE(numout,*)'The float number',jfl,'is out of the sea.'
-               IF(lwp) WRITE(numout,*)'geographical position',flxx(jfl),flyy(jfl),flzz(jfl)
-               IF(lwp) WRITE(numout,*)'index position',tpifl(jfl),tpjfl(jfl),tpkfl(jfl)
+               IF(lwp) THEN
+                  WRITE(numout,*)'*****************************'
+                  WRITE(numout,*)'!!!!!!!  WARNING   !!!!!!!!!!'
+                  WRITE(numout,*)'*****************************'
+                  WRITE(numout,*)'The float number',jfl,'is out of the sea.'
+                  WRITE(numout,*)'geographical position',flxx(jfl),flyy(jfl),flzz(jfl)
+                  WRITE(numout,*)'index position',tpifl(jfl),tpjfl(jfl),tpkfl(jfl)
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
             ENDIF
          END DO
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/florst.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/florst.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/FLO/florst.F90	(revision 10986)
@@ -67,4 +67,5 @@
             WRITE(numout,*) 'flo_rst : write in  restart_float file '
             WRITE(numout,*) '~~~~~~~    '
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
@@ -118,4 +119,5 @@
                   ENDIF
                END DO
+               IF(lflush) CALL FLUSH(numout)
             ENDIF
          ENDIF
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/in_out_manager.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/in_out_manager.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/in_out_manager.F90	(revision 10986)
@@ -129,6 +129,8 @@
    INTEGER ::   nn_isplt         !: number of processors following i
    INTEGER ::   nn_jsplt         !: number of processors following j
+   LOGICAL ::   ln_flush         !: flush numout flag
    !                                          
    INTEGER ::   nprint, nictls, nictle, njctls, njctle, isplt, jsplt    !: OLD namelist names
+   LOGICAL ::   lflush
 
    INTEGER ::   ijsplt     =    1      !: nb of local domain = nb of processors
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/iom.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/iom.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/iom.F90	(revision 10986)
@@ -321,5 +321,8 @@
         ENDIF
 !set name of the restart file and enable available fields
-        if(lwp .AND. nprint > 1) WRITE(numout,*) 'Setting restart filename (for XIOS) to: ',rst_file
+        if(lwp .AND. nprint > 1) THEN
+           WRITE(numout,*) 'Setting restart filename (for XIOS) to: ',rst_file
+           IF(lflush) CALL FLUSH(numout)
+        ENDIF
         CALL xios_get_handle("file_definition", filegroup_hdl )
         CALL xios_add_child(filegroup_hdl, file_hdl, 'rrestart')
@@ -346,5 +349,8 @@
                         scalar_ref = "grid_scalar", operation = "instant")
                 END SELECT
-                IF(lwp .AND. nprint > 1) WRITE(numout,*) 'XIOS read: ', TRIM(rst_rfields(i)%vname), ' enabled in ', TRIM(rst_file)
+                IF(lwp .AND. nprint > 1) THEN
+                   WRITE(numout,*) 'XIOS read: ', TRIM(rst_rfields(i)%vname), ' enabled in ', TRIM(rst_file)
+                   IF(lflush) CALL FLUSH(numout)
+                ENDIF
            ENDIF
          ENDIF
@@ -537,5 +543,8 @@
 
 !set name of the restart file and enable available fields
-        IF(lwp .AND. nprint > 1) WRITE(numout,*) 'Setting restart filename (for XIOS write) to: ',cdrst_file
+        IF(lwp .AND. nprint > 1) THEN
+           WRITE(numout,*) 'Setting restart filename (for XIOS write) to: ',cdrst_file
+           IF(lflush) CALL FLUSH(numout)
+        ENDIF
         CALL xios_get_handle("file_definition", filegroup_hdl )
         CALL xios_add_child(filegroup_hdl, file_hdl, 'wrestart')
@@ -543,9 +552,15 @@
            CALL xios_set_file_attr( "wrestart", type="one_file", enabled=.TRUE.,& 
                                     mode="write", output_freq=xios_timestep) 
-           if(lwp .AND. nprint > 1) write(numout,*) 'OPEN ', trim(cdrst_file), ' in one_file mode' 
+           IF(lwp .AND. nprint > 1) THEN
+              write(numout,*) 'OPEN ', trim(cdrst_file), ' in one_file mode' 
+              IF(lflush) CALL FLUSH(numout)
+           ENDIF
         ELSE  
            CALL xios_set_file_attr( "wrestart", type="multiple_file", enabled=.TRUE.,& 
                                     mode="write", output_freq=xios_timestep) 
-           if(lwp .AND. nprint > 1) write(numout,*) 'OPEN ', trim(cdrst_file), ' in multiple_file mode' 
+           IF(lwp .AND. nprint > 1) THEN
+              write(numout,*) 'OPEN ', trim(cdrst_file), ' in multiple_file mode' 
+              IF(lflush) CALL FLUSH(numout)
+           ENDIF
         ENDIF 
         CALL xios_set_file_attr( "wrestart", name=trim(cdrst_file))
@@ -824,6 +839,8 @@
                iom_file(jf)%nfid       = 0          ! free the id 
                IF( PRESENT(kiomid) )   kiomid = 0   ! return 0 as id to specify that the file was closed
-               IF(lwp  .AND. nprint > 1) &
+               IF(lwp  .AND. nprint > 1) THEN
                  WRITE(numout,*) TRIM(clinfo)//' close file: '//TRIM(iom_file(jf)%name)//' ok'
+                 IF(lflush) CALL FLUSH(numout)
+               ENDIF
             ELSEIF( PRESENT(kiomid) ) THEN
                WRITE(ctmp1,*) '--->',  kiomid
@@ -942,5 +959,8 @@
       ELSE
 #if defined key_iomput
-         IF(lwp .AND. nprint > 1) WRITE(numout,*) 'XIOS RST READ (0D): ', trim(cdvar)
+         IF(lwp .AND. nprint > 1) THEN
+            WRITE(numout,*) 'XIOS RST READ (0D): ', trim(cdvar)
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          CALL iom_swap( TRIM(crxios_context) )
          CALL xios_recv_field( trim(cdvar), pvar)
@@ -1267,6 +1287,8 @@
 
             IF( istop == nstop ) THEN   ! no additional errors until this point...
-               IF(lwp .AND. nprint > 1) &
+               IF(lwp .AND. nprint > 1) THEN
                   WRITE(numout,"(10x,' read ',a,' (rec: ',i6,') in ',a,' ok')") TRIM(cdvar), itime, TRIM(iom_file(kiomid)%name)
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
              
                !--- overlap areas and extra hallows (mpp)
@@ -1298,5 +1320,8 @@
          IF( PRESENT(pv_r3d) ) THEN
             pv_r3d(:, :, :) = 0.
-            if(lwp .AND. nprint > 1) write(numout,*) 'XIOS RST READ (3D): ',trim(cdvar)
+            IF(lwp .AND. nprint > 1) THEN
+               write(numout,*) 'XIOS RST READ (3D): ',trim(cdvar)
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL xios_recv_field( trim(cdvar), pv_r3d)
             IF(idom /= jpdom_unknown ) then
@@ -1305,5 +1330,8 @@
          ELSEIF( PRESENT(pv_r2d) ) THEN
             pv_r2d(:, :) = 0.
-            if(lwp .AND. nprint > 1) write(numout,*) 'XIOS RST READ (2D): ', trim(cdvar)
+            IF(lwp .AND. nprint > 1) THEN
+               write(numout,*) 'XIOS RST READ (2D): ', trim(cdvar)
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL xios_recv_field( trim(cdvar), pv_r2d)
             IF(idom /= jpdom_unknown ) THEN
@@ -1312,5 +1340,8 @@
          ELSEIF( PRESENT(pv_r1d) ) THEN
             pv_r1d(:) = 0.
-            if(lwp .AND. nprint > 1) write(numout,*) 'XIOS RST READ (1D): ', trim(cdvar)
+            IF(lwp .AND. nprint > 1) THEN
+               write(numout,*) 'XIOS RST READ (1D): ', trim(cdvar)
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL xios_recv_field( trim(cdvar), pv_r1d)
          ENDIF
@@ -1514,5 +1545,8 @@
 #ifdef key_iomput
       IF( kt == kwrite ) THEN
-          IF(lwp .AND. nprint > 1) write(numout,*) 'RESTART: write (XIOS 0D) ',trim(cdvar)
+          IF(lwp .AND. nprint > 1) THEN
+             write(numout,*) 'RESTART: write (XIOS 0D) ',trim(cdvar)
+             IF(lflush) CALL FLUSH(numout)
+          ENDIF
           CALL xios_send_field(trim(cdvar), pvar)
       ENDIF
@@ -1544,5 +1578,8 @@
 #ifdef key_iomput
       IF( kt == kwrite ) THEN
-         IF(lwp .AND. nprint > 1) write(numout,*) 'RESTART: write (XIOS 1D) ',trim(cdvar)
+         IF(lwp .AND. nprint > 1) THEN
+            write(numout,*) 'RESTART: write (XIOS 1D) ',trim(cdvar)
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          CALL xios_send_field(trim(cdvar), pvar)
       ENDIF
@@ -1574,5 +1611,8 @@
 #ifdef key_iomput
       IF( kt == kwrite ) THEN
-         IF(lwp .AND. nprint > 1) write(numout,*) 'RESTART: write (XIOS 2D) ',trim(cdvar)
+         IF(lwp .AND. nprint > 1) THEN
+            write(numout,*) 'RESTART: write (XIOS 2D) ',trim(cdvar)
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          CALL xios_send_field(trim(cdvar), pvar)
       ENDIF
@@ -1604,5 +1644,8 @@
 #ifdef key_iomput
       IF( kt == kwrite ) THEN
-         IF(lwp .AND. nprint > 1) write(numout,*) 'RESTART: write (XIOS 3D) ',trim(cdvar)
+         IF(lwp .AND. nprint > 1) THEN
+            write(numout,*) 'RESTART: write (XIOS 3D) ',trim(cdvar)
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          CALL xios_send_field(trim(cdvar), pvar)
       ENDIF
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/iom_nf90.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/iom_nf90.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/iom_nf90.F90	(revision 10986)
@@ -88,5 +88,8 @@
          !                                       !=========================!
          IF( ldwrt ) THEN  ! ... in write mode
-            IF(lwp .AND. nprint > 0) WRITE(numout,*) TRIM(clinfo)//' open existing file: '//TRIM(cdname)//' in WRITE mode'
+            IF(lwp .AND. nprint > 0) THEN
+               WRITE(numout,*) TRIM(clinfo)//' open existing file: '//TRIM(cdname)//' in WRITE mode'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             IF( snc4set%luse ) THEN
                CALL iom_nf90_check(NF90_OPEN( TRIM(cdname), NF90_WRITE  , if90id ), clinfo)
@@ -96,5 +99,8 @@
             CALL iom_nf90_check(NF90_SET_FILL( if90id, NF90_NOFILL, idmy                          ), clinfo)
          ELSE              ! ... in read mode
-            IF(lwp .AND. nprint > 0) WRITE(numout,*) TRIM(clinfo)//' open existing file: '//TRIM(cdname)//' in READ mode'
+            IF(lwp .AND. nprint > 0) THEN
+               WRITE(numout,*) TRIM(clinfo)//' open existing file: '//TRIM(cdname)//' in READ mode'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL iom_nf90_check(NF90_OPEN( TRIM(cdname), NF90_NOWRITE, if90id, chunksize = ichunk ), clinfo)
          ENDIF
@@ -107,5 +113,8 @@
                cdname = TRIM(cltmp)
             ENDIF
-            IF(lwp .AND. nprint > 0) WRITE(numout,*) TRIM(clinfo)//' create new file: '//TRIM(cdname)//' in WRITE mode'
+            IF(lwp .AND. nprint > 0) THEN
+               WRITE(numout,*) TRIM(clinfo)//' create new file: '//TRIM(cdname)//' in WRITE mode'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
 
             IF( llclobber ) THEN   ;   imode = IOR( NF90_64BIT_OFFSET, NF90_CLOBBER   )
@@ -113,5 +122,8 @@
             ENDIF
             IF( snc4set%luse ) THEN
-               IF(lwp .AND. nprint > 0) WRITE(numout,*) TRIM(clinfo)//' creating file: '//TRIM(cdname)//' in hdf5 (netcdf4) mode'
+               IF(lwp .AND. nprint > 0) THEN
+                  WRITE(numout,*) TRIM(clinfo)//' creating file: '//TRIM(cdname)//' in hdf5 (netcdf4) mode'
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
                CALL GET_NF90_SYMBOL("NF90_HDF5", ihdf5)
                IF( llclobber ) THEN   ;   imode = IOR(ihdf5, NF90_CLOBBER)
@@ -165,5 +177,8 @@
                &                                       len  = iom_file(kiomid)%lenuld ), clinfo )
          ENDIF
-         IF(lwp .AND. nprint > 0) WRITE(numout,*) '                   ---> '//TRIM(cdname)//' OK'
+         IF(lwp .AND. nprint > 0) THEN
+            WRITE(numout,*) '                   ---> '//TRIM(cdname)//' OK'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       ELSE
          kiomid = 0               ! return error flag
@@ -562,5 +577,8 @@
          ! trick: defined to 0 to say that dimension variables are defined but not yet written
          iom_file(kiomid)%dimsz(1, 1)  = 0   
-         IF(lwp .AND. nprint > 1) WRITE(numout,*) TRIM(clinfo)//' define dimension variables done'
+         IF(lwp .AND. nprint > 1) THEN
+            WRITE(numout,*) TRIM(clinfo)//' define dimension variables done'
+            IF(lflush) CALL FLUSH(numout)
+          ENDIF
       ENDIF
       ! define the data if it is not already done
@@ -637,7 +655,13 @@
             CALL iom_nf90_check(SET_NF90_DEF_VAR_CHUNKING(if90id, idvar, ichunkalg, ichunksz), clinfo)
             CALL iom_nf90_check(SET_NF90_DEF_VAR_DEFLATE(if90id, idvar, ishuffle, ideflate, ideflate_level), clinfo)
-            IF(lwp .AND. nprint > 1) WRITE(numout,*) TRIM(clinfo)//' chunked ok. Chunks sizes: ', ichunksz
-         ENDIF
-         IF(lwp .AND. nprint > 1) WRITE(numout,*) TRIM(clinfo)//' defined ok'
+            IF(lwp .AND. nprint > 1) THEN
+               WRITE(numout,*) TRIM(clinfo)//' chunked ok. Chunks sizes: ', ichunksz
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
+         ENDIF
+         IF(lwp .AND. nprint > 1) THEN
+            WRITE(numout,*) TRIM(clinfo)//' defined ok'
+            IF(lflush) CALL FLUSH(numout)
+          ENDIF
       ELSE
          idvar = kvid
@@ -685,5 +709,8 @@
                CALL iom_nf90_check( NF90_INQUIRE_DIMENSION( if90id, 3, len = iom_file(kiomid)%dimsz(1,3) ), clinfo )
                iom_file(kiomid)%dimsz(1  , 4) = 1   ! unlimited dimension
-               IF(lwp .AND. nprint > 1) WRITE(numout,*) TRIM(clinfo)//' write dimension variables done'
+               IF(lwp .AND. nprint > 1) THEN
+                  WRITE(numout,*) TRIM(clinfo)//' write dimension variables done'
+                  IF(lflush) CALL FLUSH(numout)
+               ENDIF
             ENDIF
          ENDIF
@@ -703,5 +730,8 @@
          IF( iom_file(kiomid)%luld(idvar) )   iom_file(kiomid)%dimsz(iom_file(kiomid)%ndims(idvar), idvar)    &
                &                            = iom_file(kiomid)%dimsz(iom_file(kiomid)%ndims(idvar), idvar) + 1
-         IF(lwp .AND. nprint > 0) WRITE(numout,*) TRIM(clinfo)//' written ok'
+         IF(lwp .AND. nprint > 0) THEN
+            WRITE(numout,*) TRIM(clinfo)//' written ok'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
       ENDIF
       !     
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/prtctl.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/prtctl.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/prtctl.F90	(revision 10986)
@@ -493,6 +493,9 @@
          zidom = zidom + ilcitl(ji,1) - nrecil
       END DO
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*)' sum ilcitl(i,1) = ', zidom, ' jpiglo = ', jpiglo
+      IF(lwp) THEN 
+         WRITE(numout,*)
+         WRITE(numout,*)' sum ilcitl(i,1) = ', zidom, ' jpiglo = ', jpiglo
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       
       zjdom = nrecjl
@@ -500,6 +503,9 @@
          zjdom = zjdom + ilcjtl(1,jj) - nrecjl
       END DO
-      IF(lwp) WRITE(numout,*)' sum ilcitl(1,j) = ', zjdom, ' jpjglo = ', jpjglo
-      IF(lwp) WRITE(numout,*)
+      IF(lwp) THEN
+         WRITE(numout,*)' sum ilcitl(1,j) = ', zjdom, ' jpjglo = ', jpjglo
+         WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/restart.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/restart.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/IOM/restart.F90	(revision 10986)
@@ -104,4 +104,5 @@
                   ENDIF
                ENDIF
+               IF(lflush) CALL FLUSH(numout)
             ENDIF
             !
@@ -211,4 +212,5 @@
             IF ( snc4set%luse )      WRITE(numout,*) 'rst_read : configured with NetCDF4 support'
             WRITE(numout,*) '~~~~~~~~'
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
          lxios_sini = .FALSE.
@@ -223,5 +225,8 @@
              crxios_context = 'nemo_rst'
              IF( .NOT.lxios_set ) THEN
-                 IF(lwp .AND. nprint > 0) WRITE(numout,*) 'Enable restart reading by XIOS'
+                 IF(lwp .AND. nprint > 0) THEN
+                    WRITE(numout,*) 'Enable restart reading by XIOS'
+                    IF(lflush) CALL FLUSH(numout)
+                 ENDIF
                  CALL iom_init( crxios_context, ld_tmppatch = .false. )
                  lxios_set = .TRUE.
@@ -230,5 +235,8 @@
          IF( TRIM(Agrif_CFixed()) /= '0' .AND. lrxios) THEN
              CALL iom_init( crxios_context, ld_tmppatch = .false. )
-             IF(lwp .AND. nprint > 0) WRITE(numout,*) 'Enable restart reading by XIOS for AGRIF'
+             IF(lwp .AND. nprint > 0) THEN
+                WRITE(numout,*) 'Enable restart reading by XIOS for AGRIF'
+                IF(lflush) CALL FLUSH(numout)
+             ENDIF
              lxios_set = .TRUE.
          ENDIF 
@@ -264,6 +272,8 @@
       IF( ln_diurnal ) CALL iom_get( numror, jpdom_autoglo, 'Dsst' , x_dsst, ldxios = lrxios ) 
       IF ( ln_diurnal_only ) THEN 
-         IF(lwp) WRITE( numout, * ) &
-         &   "rst_read:- ln_diurnal_only set, setting rhop=rau0" 
+         IF(lwp) THEN
+            WRITE( numout, * ) "rst_read:- ln_diurnal_only set, setting rhop=rau0" 
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          rhop = rau0
          CALL iom_get( numror, jpdom_autoglo, 'tn'     , w3d, ldxios = lrxios ) 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LBC/lib_mpp.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LBC/lib_mpp.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LBC/lib_mpp.F90	(revision 10986)
@@ -617,5 +617,8 @@
          !                                       --------------------------
          IF ( SIZE(todelay(idvar)%z1d) /= isz ) THEN                  ! Check dimension coherence
-            IF(lwp) WRITE(numout,*) ' WARNING: the nb of delayed variables in restart file is not the model one'
+            IF(lwp) THEN
+               WRITE(numout,*) ' WARNING: the nb of delayed variables in restart file is not the model one'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             DEALLOCATE(todelay(idvar)%z1d)
             ndelayid(idvar) = -1                                      ! do as if we had no restart
@@ -684,5 +687,8 @@
          !                                       --------------------------
          IF ( SIZE(todelay(idvar)%z1d) /= isz ) THEN                  ! Check dimension coherence
-            IF(lwp) WRITE(numout,*) ' WARNING: the nb of delayed variables in restart file is not the model one'
+            IF(lwp) THEN
+               WRITE(numout,*) ' WARNING: the nb of delayed variables in restart file is not the model one'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             DEALLOCATE(todelay(idvar)%z1d)
             ndelayid(idvar) = -1                                      ! do as if we had no restart
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LBC/mppini.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LBC/mppini.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/LBC/mppini.F90	(revision 10986)
@@ -94,4 +94,5 @@
          WRITE(numout,*) '   l_Iperio = ', l_Iperio, '    l_Jperio = ', l_Jperio 
          WRITE(numout,*) '     npolj  = ',   npolj , '      njmpp  = ', njmpp
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -189,4 +190,5 @@
          WRITE(numout,*) '~~~~~~~~ '
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       IF( jpni < 1 .OR. jpnj < 1 ) THEN
@@ -211,4 +213,5 @@
             WRITE(numout,9000) '      - has mpi subdomains with a maximum size of (jpi = ',  iimax, ', jpj = ',  ijmax,   &
                &                                                             ', jpi*jpj = ',  iimax* ijmax, ')'
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
          IF( iimax*ijmax < jpimax*jpjmax ) THEN   ! chosen subdomain size is larger that the best subdomain size
@@ -264,4 +267,5 @@
             ENDIF
             WRITE(numout,*)
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
          CALL mpp_init_bestpartition( mppsize, ldlist = .TRUE. )   ! must be done by all core
@@ -284,4 +288,5 @@
             WRITE(numout,9003) '   Number of suppressed land subdomains = ', jpni*jpnj - inijmin
             WRITE(numout,*)
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
       ENDIF
@@ -337,4 +342,5 @@
          WRITE(numout,*) '      sum ilci(i,1) = ', sum(ilci(:,1)), ' jpiglo = ', jpiglo
          WRITE(numout,*) '      sum ilcj(1,j) = ', sum(ilcj(1,:)), ' jpjglo = ', jpjglo
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
      
@@ -507,4 +513,6 @@
             il1 = il1+ifreq
          END DO
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
  9400    FORMAT('           ***'   ,20('*************',a3)    )
  9403    FORMAT('           *     ',20('         *   ',a3)    )
@@ -512,5 +520,4 @@
  9402    FORMAT('       ',i3,' *  ',20(i3,'  x',i3,'   *   ') )
  9404    FORMAT('           *  '   ,20('      ',i3,'   *   ') )
-      ENDIF
          
       ! just to save nono etc for all proc
@@ -647,4 +654,5 @@
          WRITE(numout,*) '      nrecj  = ', nrecj  
          WRITE(numout,*) '      nn_hls = ', nn_hls 
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -655,4 +663,5 @@
             WRITE(numout,*)
             WRITE(numout,*) '   ==>>>   North fold boundary prepared for jpni >1'
+            IF(lflush) CALL FLUSH(numout)
             ! additional prints in layout.dat
          ENDIF
@@ -948,4 +957,5 @@
             WRITE(numout,         *) '  --------------------------------------', '-----', '--------------'
             WRITE(numout,*)
+            IF(lflush) CALL FLUSH(numout)
          END IF
          iitarget = MINLOC( inbi0(:)*inbj0(:), mask = inbi0(:)*inbj0(:) >= knbij, dim = 1 )
@@ -955,8 +965,11 @@
             inbij = COUNT(llisoce)
             DEALLOCATE( llisoce )
-            IF(lwp) WRITE(numout,'(a, i5, a, i5, a, i4, a, i4, a, i9, a, i5, a, i5, a)')    &
+            IF(lwp) THEN
+               WRITE(numout,'(a, i5, a, i5, a, i4, a, i4, a, i9, a, i5, a, i5, a)')    &
                &     'nb_cores ' , inbij,' oce + ', inbi0(ji)*inbj0(ji) - inbij             &
                &                                , ' land ( ', inbi0(ji),' x ', inbj0(ji),   &
                & ' ), nb_points ', iszi0(ji)*iszj0(ji),' ( ', iszi0(ji),' x ', iszj0(ji),' )'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
          END DO
          DEALLOCATE( inbi0, inbj0, iszi0, iszj0 )
@@ -1171,4 +1184,5 @@
           WRITE(numout,*) '                    ihals = ', ihals(1), ihals(2)
           WRITE(numout,*) '                    ihale = ', ihale(1), ihale(2)
+          IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
